variables:
  KUBECONFIG: /etc/deploy/config


stages:
  - build
  - deploy

build image:
  image: docker:stable
  tags:
    - docker
  services:
    - docker:dind
  only:
    - master
  stage: build
  before_script:
    - echo $FIREBASE_JSON | base64 -d > "./firebase.json"
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t registry.gitlab.com/scepter.dev/user-service:latest .
    - docker push registry.gitlab.com/scepter.dev/user-service:latest

deploy functions:
  image: rambabusaravanan/firebase
  stage: deploy
  only:
    - master
  before_script:
    - echo "$FIREBASE_JSON" | base64 -d > "./firebaseServiceAccount.json"
  script:
    - yarn
    - cd functions && yarn --ignore-engines
    - firebase deploy --only functions --token $FIREBASE_DEPLOY_KEY

deploy image:
  image: dtzar/helm-kubectl
  tags:
    - docker
  only:
    - master
  stage: deploy
  before_script:
    - mkdir -p /etc/deploy
    - echo $KUBECTL_CONFIG
    - echo $KUBECTL_CONFIG | base64 -d > ${KUBECONFIG}
  script:
    - kubectl rollout restart deployment/user-service --namespace 404936-scepter
